unit Unit1;
//Source de Marchioni Valrian
//loub1@caramail.com
//icq: 30687888

//principe: on va examiner pixel par pixel chaque ligne d'un bitmap
//a la recherche de zones (rgions) non-transparentes (zones d'epaisseur 1 pixel)
//a chaque fois qu'on en trouve une, on l'ajoute  une zone 'finale':reg
//on applique la region a une seconde fiche
//et on lui applique le bitmap de depart
//
//Ce programme utilise les api: combinergn, setwindowrgn et CreateRectRgn

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ExtDlgs;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    Button3: TButton;
    Button4: TButton;
    ColorDialog1: TColorDialog;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
    { Dclarations prives}
  public
     bmp:tbitmap;
    { Dclarations publiques}
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.DFM}



procedure TForm1.Button4Click(Sender: TObject);
begin
close;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
button3.Enabled:=false;
form2.close;
end;

procedure TForm1.Button1Click(Sender: TObject);
var x, y,reg,  regtemp, debut, fin:integer;etaitblanc, first:boolean;
begin
if (OpenPictureDialog1.execute) and (ColorDialog1.execute) then
   begin
   bmp.LoadFromFile(openpicturedialog1.FileName);  //le bitmap qui sera utilis
   bmp.TransparentColor:=colordialog1.Color;       //la couleur de tout ce qui n'est pas compris dans la fiche
                                                   //attention, il faut un bord (un cadre) de couleur transparente tout autour du dessin
                                                   //pour que ca fonctionne
   form2.height:=bmp.height;   //on adapte les
   form2.width:=bmp.width;     //dimensions de la fiche

   first:=true;                //c'est pour savoir si on a deja cr une rgion : voir CombineRgn (ncessite une region non vide)
   for y:=1 to bmp.height do
       begin
       debut:=1;               //debut=debut de la zone non-traansparente
       fin:=1;                 //fin  =fin   """"""""""""""""""""""""""""
       etaitblanc:=true;       //etaitblanc, c'est pour savoir si le pixel examin prcdemment tait
                               //transparent ou pas (ben oui j'avais d'abord commenc par le blanc, ce serait
                               //plus logique d'appeler cette variable etaittraansparente, mais c'est trop long a ecrire
       for x:=1 to bmp.width do
         begin
         if bmp.Canvas.Pixels[x,y]=colordialog1.Color then  //si le pixel est transparent
           begin
           if etaitblanc=false then  //et que le prcdent ne l'etait pas
              begin
              fin:=x-1;   //le dernier pixel non transparent etait le precedent
              if first=true then //si c'est la 1region qu'on cre:
                 begin
                 reg:=CreateRectRgn(debut,y,fin+1,y+1); //on la cre
                 first:=false;  //la prochaine ne sera plus la premiere
                 end else
                 begin//si c'est pas la premiere region
                 regtemp:=createrectrgn(debut,y,fin+1,y+1);//on en cre une temporaire
                 CombineRgn(reg, reg, regtemp, rgn_or);//on l'ajoute  reg qui sera la region finale avec rgn_or (voir autres possibilits dans l'aide)
                 deleteobject(regtemp);//on supprime la region temporaire pour rester propres (si on ne le fait pas, ca se fait autom. qd on ferme l'application)
                 end;
              end;
           etaitblanc:=true;
           end else      //le pixel n'est pas transparent
           begin
           if etaitblanc=true then debut:=x;//ben oui rien que ca
           etaitblanc:=false;
           if x=bmp.width-1 then //on arrive au dernier point de la ligne
           if first=true then //si c'est la 1region qu'on cre:
                 begin
                 reg:=CreateRectRgn(debut,y,x,y+1); //on la cre
                 first:=false;  //la prochaine ne sera plus la premiere
                 end else
                 begin//si c'est pas la premiere region
                 regtemp:=createrectrgn(debut,y,x,y+1);//on en cre une temporaire
                 CombineRgn(reg, reg, regtemp, rgn_or);//on l'ajoute  reg qui sera la region finale avec rgn_or (voir autres possibilits dans l'aide)
                 deleteobject(regtemp);//on supprime la region temporaire pour rester propres (si on ne le fait pas, ca se fait autom. qd on ferme l'application)
                 end;
           end;
        end;
    end;
  form2.show;//on affiche la fiche sur laquelle on va appliquer la region

  SetWindowRgn(form2.handle, reg,true);//on applique la region
  form2.Canvas.Draw(0,0,bmp);//on lui dessine le canvas de l'image choisie (voir aussi form2.mousemove)
  application.ProcessMessages;//on le laisse un peu souffler (pas obligatoire, c'est juste par compassion pour le processeur)
  button3.enabled:=true;//on permet de la fermer
//conseill: les deux lignes qui suivent
//si on choisit un bitmap avec une image non transparente qui se situe dans l'extrmit
//droite et tout en bas, et que la fiche se situe elle aussi en bas a droite de l'cran,
//on n'a pas accs a la fiche, contrairement aux fiches traditionnelles (rectangulaires)
//que l'on ne peut jamais 'perdre'
  form2.top:=0;
  form2.left:=0;
  form2.BringToFront;//on met la fiche en avant-plan
  form2.canvas.draw(0,0,form1.bmp);//effectue dja un premier rafraichissement
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
bmp:=tbitmap.create;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
bmp.free;
end;

end.
